//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixProbWins2.h"
#include "MixProbExpDlgs.h"
#include "MsgBoxDlgs.h"
#include "Mixmaster.h"
#include "WipeDlgs.h"
#include "HelpDlgs.h"
#include "FileMan.h"
#include "Global.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma link "MixKeyWins2"
#pragma resource "*.dfm"
TMixProbWin2 *MixProbWin2=NULL;
const AnsiString ProbRing = mprobtxt;
const AnsiString MixShortCap = "Mix Dups";
const AnsiString MixLongCap = "Mixmaster Duplicate Keys";
//---------------------------------------------------------------------------
void __fastcall OpenMixProblems(AnsiString &filename)
{
   TStringList *probs = new TStringList();
   if (FileExists(filename)) probs->LoadFromFile(filename); // don't open if no contents
   if (probs->Count) MixProbWin2 = new TMixProbWin2(AppMainForm,true);
   else if (FileExists(mprobtxt)) zapfile(mprobtxt,1);
   delete probs;
}
//---------------------------------------------------------------------------
__fastcall TMixProbWin2::TMixProbWin2(TComponent* Owner)
   : TMixKeyWin2(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMixProbWin2::TMixProbWin2(TComponent* Owner, bool Minimized)
   : TMixKeyWin2(Owner)
{
   hidedisabled = false;
   HideDisBtn->Bitmap->Assign(bmpShowAll);
   dominimize = Minimized;
   Caption = dominimize?MixShortCap:MixLongCap;
   keynodes = new TList();
   keys = new TMixKeyList2();
   int H = 64+((6/*keys->Count+1*/)*19);
   if (H < 175) H = 175;
   if (H < Height) Height = H;
   okclicked = false;
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TMixProbWin2::TMixProbWin2(TComponent* Owner, TMixKeyList2 *Imports)
   : TMixKeyWin2(Owner,Imports)
{
   hidedisabled = false;
   HideDisBtn->Bitmap->Assign(bmpShowAll);
   dominimize = false;
   keynodes = new TList();
   keys = new TMixKeyList2();
   int H = 64+((6/*keys->Count+1*/)*19);
   if (H < 175) H = 175;
   if (H < Height) Height = H;
   okclicked = false;
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TMixProbWin2::~TMixProbWin2()
{
   if (this==MixProbWin2) MixProbWin2 = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::LoadKeys()
{
   AnsiString type2str,tline,kline;
   cap = dominimize?MixShortCap:MixLongCap;
   TStringList *probkeys = new TStringList();
   if (FileExists(ProbRing)) probkeys->LoadFromFile(ProbRing);
   TrimNulls(probkeys);
   TMixKeyList2 *KEYS = (TMixKeyList2*)keys;
   if (!KEYS->type2) KEYS->type2 = new TStringList();
   KEYS->type2->Clear();
   KEYS->Clear();
   if (probkeys->Count && probkeys->Strings[0].Pos("type2=|"))
   {
      type2str = probkeys->Strings[0]; probkeys->Delete(0);
      int i=1; while((tline=GetToken(i++,type2str,"|"))!="")
         KEYS->type2->Add(tline);
   }
   KEYS->LoadFromStrings(probkeys);
   delete probkeys;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::SaveKeys()
{
   if (keys)
   {
      if (!keys->Count)
      {
         if (FileExists(ProbRing)) zapfile(ProbRing,1);
         Sleep(100);
         Close();
         return;
      }

      AnsiString type2str = "type2=";
      TStringList *type2 = ((TMixKeyList2*)keys)->type2;
      for (int i=0; i<type2->Count; i++) type2str += "|"+type2->Strings[i];
      TStringList *keyblks = new TStringList();
      keyblks->Add(type2str);
      for (int i=0; i<keys->Count; i++)
         keyblks->Add(((TStrings*)keys->Objects[i])->Text);
      keyblks->SaveToFile(ProbRing);
      newkeys->Clear();
      TreeView->Invalidate();
      delete keyblks;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::DeleteKey(int atPos)
{
   if (curkey<0 || curkey>=keynodes->Count) return;
   if (MsgDlg(AppMainForm,"Delete the current mixmaster key?","Confirm",MB_OKCANCEL)==IDOK)
   {
      RefreshBtn->Enabled = SaveBtn->Enabled = true;
      int pos; if (keys->FindKey(NodeKey(curkey),pos))
      {
          keys->DeleteKey(pos);
          LoadTreeViewQuiet();
          SetNothingSelected();
          if (!keys->Count)
          {
             Snooze(200);
             Close();
          }
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::FormResize(TObject *Sender)
{
   TMixKeyWin2::FormResize(Sender);
   Caption = WindowState==wsMinimized?MixShortCap:MixLongCap;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::TransferKeysItemClick(TObject *Sender)
{
   if (!keys->Count) return;
   if (MsgBoxHwnd(Handle,"Transfer ALL keys to your mixmaster keyring?",
      "Confirm",MB_OKCANCEL)==IDOK)
   {
      Caption = "Transfering keys...";
      AppProcessMessages(); Sleep(100);

      if (!MixKeyWin2) MixKeyWin2 = new TMixKeyWin2(AppMainForm);
      else MixKeyWin2->WindowState = wsNormal;
      AppProcessMessages(); Sleep(300);
      MixKeyWin2->AddKeysImport(keys);
      keys->Clear();
      ClearTree();

      Caption = MixLongCap;
      AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"All keys transfered!");
      AppProcessMessages(); Sleep(100);
      Close();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::TransferKeyItemClick(TObject *Sender)
{
   if (curkey<0 || curkey>=keys->Count) return;
   if (MsgBoxHwnd(Handle,"Transfer the current key to your mixmaster keyring?",
      "Confirm",MB_OKCANCEL)==IDOK)
   {
      Caption = "Transfering key...";
      AppProcessMessages(); Sleep(100);

      TMixKeyList2 *imports = new TMixKeyList2(keys->Key(curkey));
      if (!MixKeyWin2) MixKeyWin2 = new TMixKeyWin2(AppMainForm,imports);
      else
      {
         MixKeyWin2->WindowState = wsNormal;
         AppProcessMessages(); Sleep(100);
         MixKeyWin2->AddKeysImport(imports);
      }
      DeleteKey(curkey);

      AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Key transfered!");
      if (keys->Count) LoadTreeView();
      Sleep(100);
   }
   Caption = MixLongCap;
   if (!TreeView->Items->Count)
   {
      Sleep(100);
      Close();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (!keys->Count) zapfile(ProbRing,1);
   else SaveKeys();
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::FormClose(TObject *Sender, TCloseAction &Action)
{
   if (!keys->Count) Action = caFree;
   else
   {
      if (!okclicked) ExplainMixProblemWinCantClose(AppMainForm);
      Action = caMinimize;
      okclicked = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::HelpBtnClick(TObject *Sender)
{
   OpenHelp("MixmasterKeysDup","Duplicate Key Manager","");
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::ClearAllBtnClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,
      s("Clear Mixmaster Duplicate Keys\n")+
      s("If you clear the keyring, you will be unable to\n")+
      s("undelete the items.\n\n")+
      s("Clear it anyway?"),
      "Confirm",MB_OKCANCEL)==IDOK)
   {
      SetNothingSelected();
      //OkBtn->Click();
      keys->Clear();
      ClearTree();
      Sleep(300);
      Close();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::PopupMenu3Popup(TObject *Sender)
{
   TransferKeyItem->Enabled = TreeView->Selected!=NULL;
   TransferKeysItem->Enabled = keys->Count>1;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::OkBtnClick(TObject *Sender)
{
   okclicked = true;
   TMixKeyWin2::OkBtnClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin2::FormShow(TObject *Sender)
{
   if (dominimize) WindowState = wsMinimized;
}
//---------------------------------------------------------------------------
