//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#pragma hdrstop

#include "fileman.h"
#include "PgpFiles.h"
#include "mixmaster.h"
#include "cyberpunk.h"
#include "Global.h"
#include "view.h"
//---------------------------------------------------------------------------
AnsiString __fastcall PgpDir()
{
   AnsiString path = ExtractFilePath(GetAppIni(PgpPubRing,""));
   if (!path.IsEmpty() && DirectoryExists(path)) return path;

   path=getenv("PGPPATH");
   if (path.IsEmpty()) path = ExtractFilePath(AppExeName);//GetCurrentDir();
   if (path.Length() && path[path.Length()]!='\\') path += "\\";
   return path;
}
//---------------------------------------------------------------------------
AnsiString __fastcall PgpPublicRing()
{
   AnsiString name = GetAppIni(PgpPubRing,"");
   if (!name.IsEmpty() && FileExists(name)) return name;

   name=PgpDir()+"pubring.pgp";
   if (!FileExists(name)) name = PgpDir()+"pubring.pubkr";
   if (!FileExists(name)) name = PgpDir()+"pubring.pkr";
   if (!FileExists(name)) name = "";
   return name;
}
//---------------------------------------------------------------------------
AnsiString __fastcall PgpSecretRing()
{
   AnsiString name = GetAppIni(PgpSecRing,"");
   if (!name.IsEmpty() && FileExists(name)) return name;

   name=PgpDir()+"secring.pgp";
   if (!FileExists(name)) name = PgpDir()+"secring.seckr";
   if (!FileExists(name)) name = PgpDir()+"secring.skr";
   if (!FileExists(name)) name = "";
   return name;
}
//---------------------------------------------------------------------------
AnsiString __fastcall PgpRemailRing()
{
   AnsiString remring=MixDir()+CRingTxt;
   if (!FileExists(remring)) remring = "";
   return remring;
}
//---------------------------------------------------------------------------
AnsiString __fastcall PgpImportRing()
{
   return GetAppIni(PgpImpRing,"");
}
//---------------------------------------------------------------------------
int __fastcall BeginPgpPubKeyBlockCount(TStrings *block)
{
   int c=0; for (int i=0; i<block->Count; i++)
      if (block->Strings[i]==BeginPgpPubKeyBlock) c++;
   return c;
}
//---------------------------------------------------------------------------
bool __fastcall IsPGPArmoredHead(AnsiString line)
{
   return line==BeginPgpPubKeyBlock || line==BeginPgpSecKeyBlock;
}
//---------------------------------------------------------------------------
bool __fastcall IsPGPArmoredTail(AnsiString line)
{
   return line==EndPgpPubKeyBlock || line==EndPgpSecKeyBlock;
}
//---------------------------------------------------------------------------
bool __fastcall GetNextPGPArmored(BUFFER *asckeys, BUFFER *armored)
{
   TStringList *all = new TStringList();
   TStringList *next = new TStringList();
   all->SetText((char*)armored->data);

   bool ok=GetNextPGPArmored(next,all);
   buf_sets(asckeys,next->Text.c_str());
   buf_sets(armored,all->Text.c_str());
   delete next;
   delete all;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall GetNextPGPArmored(TStrings *asckeys, TStrings *armored)
{
   asckeys->Clear();
   AnsiString line;
   while (armored->Count && !IsPGPArmoredHead(armored->Strings[0])) armored->Delete(0);
   while (armored->Count)
   {
      asckeys->Add(armored->Strings[0]); armored->Delete(0);
      if (IsPGPArmoredTail(asckeys->Strings[asckeys->Count-1])) break;
   }
   return asckeys->Count>3;
}
//---------------------------------------------------------------------------
void __fastcall FixPgpBeginEndLines(TStrings *lines)
{
   AnsiString line;
   for (int i=0; i<lines->Count; i++)
   {
      line = lines->Strings[i];
      if (line.Pos("- "+BeginPgpMessage)==1) lines->Strings[i] = BeginPgpMessage; else
      if (line.Pos("- "+EndPgpMessage)==1) lines->Strings[i] = EndPgpMessage; else
      // these final three work together. there is no EndPgpSignedMessage
      if (line.Pos("- "+BeginPgpSignedMessage)==1) lines->Strings[i] = BeginPgpSignedMessage; else
      if (line.Pos("- "+BeginPgpSignature)==1) lines->Strings[i] = BeginPgpSignature; else
      if (line.Pos("- "+EndPgpSignature)==1) lines->Strings[i] = EndPgpSignature;
   }
}
/*void __fastcall FixPgpBeginEndLines(TStrings *lines)
{
   int idx;
   while((idx=lines->IndexOf("- "+BeginPgpMessage))>=0)
      lines->Strings[idx] = BeginPgpMessage;
   while((idx=lines->IndexOf("- "+EndPgpMessage))>=0)
      lines->Strings[idx] = EndPgpMessage;
   while((idx=lines->IndexOf("- "+BeginPgpSignedMessage))>=0)
      lines->Strings[idx] = BeginPgpSignedMessage;
   while((idx=lines->IndexOf("- "+BeginPgpSignature))>=0)
      lines->Strings[idx] = BeginPgpSignature;
   while((idx=lines->IndexOf("- "+EndPgpSignature))>=0)
      lines->Strings[idx] = EndPgpSignature;
}*/
//---------------------------------------------------------------------------
